<template>
  <section class="list">
    <ai-list>
      <ai-title slot="title" title="工作流管理" isShowBottomBorder/>
      <template #content>
        <ai-search-bar>
          <template #left>
            <el-button type="primary" icon="iconfont iconAdd" @click="handleAdd()">添加</el-button>
          </template>
          <template #right>
            <el-input size="small" placeholder="搜索" v-model="search.name" clearable
                      @change="page.current=1,getTableData()"/>
          </template>
        </ai-search-bar>

        <ai-table :tableData="tableData" :total="page.total" :current.sync="page.current" :size.sync="page.size"
                  @getList="getTableData" :col-configs="colConfigs" :dict="dict">
          <el-table-column slot="options" label="操作" fixed="right" align="center" width="300">
            <template slot-scope="{row}">
              <el-button type="text" @click="handleAdd(row.id)">编辑</el-button>
              <el-button type="text" @click="handleLogs(row.id)">台账</el-button>
              <el-button type="text" @click="handleDelete(row.id)">删除</el-button>
            </template>
          </el-table-column>
        </ai-table>
      </template>
    </ai-list>
  </section>
</template>

<script>
export default {
  name: "list",
  props: {
    instance: Function,
    dict: Object,
    permissions: Function
  },
  data() {
    return {
      search: {name: ""},
      page: {current: 1, size: 10, total: 0},
      tableData: [],
      colConfigs: [
        {prop: "name", label: "流程名称"},
        {prop: "app", label: "对应应用"},
        {prop: "id", label: "流程id"}
      ],
    }
  },
  methods: {
    getTableData() {
      this.instance.post("/app/appworkflowmanage/list", null, {
        params: {...this.page, ...this.search}
      }).then(res => {
        if (res?.data) {
          this.tableData = res.data.records
          this.page.total = res.data.total
        }
      })
    },
    handleAdd(id) {
      this.$router.push({hash: "#add", query: {id}})
    },
    handleLogs(id) {
      this.$router.push({hash: "#logs", query: {id}})
    },
    handleDelete(ids) {
      this.$confirm("是否要删除?").then(() => {
        this.instance.post("/app/appworkflowmanage/delete", null, {
          params: {ids}
        }).then(res => {
          if (res?.code == 0) {
            this.$message.success("删除成功")
            this.getTableData()
          }
        })
      }).catch(() => 0)
    }
  },
  created() {
    this.getTableData()
  }
}
</script>

<style lang="scss" scoped>
.list {
  height: 100%;
}
</style>
